import { Component, h, Prop, State, Watch } from '@stencil/core';
import QRious from 'qrious';
export class QuickomFloatingSupport {
  constructor() {
    this.url = 'https://cc.quickom.com/call/43641577091316459?k=1';
    this.qrCodeImg = '';
    this.text = 'Live Support';
  }
  componentDidLoad() {
    this.updateImgQr();
  }
  updateImgQr() {
    let qr = new QRious({
      value: this.url || 'https://cc.quickom.com/call/43641577091316459?k=1',
      size: 200,
    });
    this.imgQr = qr.toDataURL();
  }
  render() {
    return (h("a", { href: this.url, target: "_blank", class: "floating-support flex flex-col items-center" },
      h("div", { class: "box flex items-center" },
        h("img", { src: this.qrCodeImg || this.imgQr, alt: "", style: { width: '73px' } })),
      h("div", null, this.text)));
  }
  onChangeUrl() {
    this.updateImgQr();
  }
  static get is() { return "quickom-floating-support"; }
  static get originalStyleUrls() { return {
    "$": ["quickom-floating-support.styl"]
  }; }
  static get styleUrls() { return {
    "$": ["quickom-floating-support.css"]
  }; }
  static get properties() { return {
    "url": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "url",
      "reflect": false,
      "defaultValue": "'https://cc.quickom.com/call/43641577091316459?k=1'"
    },
    "qrCodeImg": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "qr-code-img",
      "reflect": false,
      "defaultValue": "''"
    },
    "text": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "text",
      "reflect": false,
      "defaultValue": "'Live Support'"
    }
  }; }
  static get states() { return {
    "imgQr": {}
  }; }
  static get watchers() { return [{
      "propName": "url",
      "methodName": "onChangeUrl"
    }]; }
}
